//////////////////////////////////////////////////////////////////////
// bot1.cpp
// -------------------------------------------------------------------
// This file is part of the follow module
// 14/03/2002
//
// Optimal Genes
//////////////////////////////////////////////////////////////////////

//------------------------------------------------//
// includes
//------------------------------------------------//
#include "External\D2Hackit.h"
#include "External\D2Client.h"
#include "follow.h"

//------------------------- skill data -----------------
#define SKILL_GAP		156
#define SKILL_OFFSET	63

#define SKILL_IN_CONV(in, val)		if ((in) > SKILL_GAP) { (val) = (in) - SKILL_OFFSET;} else { (val) = (in); }
#define SKILL_OUT_CONV(val, out)	if ((val) > SKILL_GAP){ (out) = (val) + SKILL_OFFSET;} else { (out) = (val); }

SKILLSTRUCT game_skills[] = 
{
	//skill,	Id,	charclass,	isaura,	Delay,	leftskl,	InTown,	P"ass"ive
	{"Attack",			0,	"all",	0,	0,	0,	0,	0},
	{"Kick",			1,	"all",	0,	0,	0,	0,	0},
	{"Throw",			2,	"all",	0,	0,	0,	0,	0},
	{"Unsummon",		3,	"all",	0,	0,	0,	1,	0},
	{"Left Hand Throw",	4,	"all",	0,	0,	0,	0,	0},
	{"Left Hand Swing",	5,	"all",	0,	0,	0,	0,	0},
	{"Magic Arrow",		6,	"ama",	0,	0,	0,	0,	0},
	{"Fire Arrow",		7,	"ama",	0,	0,	0,	0,	0},
	{"Inner Sight",		8,	"ama",	0,	0,	1,	0,	0},
	{"Critical Strike",	9,	"ama",	0,	0,	1,	0,	1},
	{"Jab",				10,	"ama",	0,	0,	0,	0,	0},
	{"Cold Arrow",		11,	"ama",	0,	0,	0,	0,	0},
	{"Multiple Shot",	12,	"ama",	0,	0,	0,	0,	0},
	{"Dodge",			13,	"ama",	0,	0,	1,	0,	1},
	{"Power Strike",	14,	"ama",	0,	0,	0,	0,	0},
	{"Poison Javelin",	15,	"ama",	0,	0,	0,	0,	0},
	{"Exploding Arrow",	16,	"ama",	0,	0,	0,	0,	0},
	{"Slow Missiles",	17,	"ama",	0,	0,	1,	0,	0},
	{"Avoid",			18,	"ama",	0,	0,	1,	0,	1},
	{"Impale",			19,	"ama",	0,	0,	0,	0,	0},
	{"Lightning Bolt",	20,	"ama",	0,	0,	0,	0,	0},
	{"Ice Arrow",		21,	"ama",	0,	0,	0,	0,	0},
	{"Guided Arrow",	22,	"ama",	0,	0,	0,	0,	0},
	{"Penetrate",		23,	"ama",	0,	0,	1,	0,	1},
	{"Charged Strike",	24,	"ama",	0,	0,	0,	0,	0},
	{"Plague Javelin",	25,	"ama",	0,	100,	0,	0,	0},
	{"Strafe",			26,	"ama",	0,	0,	0,	0,	0},
	{"Immolation Arrow",	27,	"ama",	0,	25,	0,	0,	0},
	{"Decoy",			28,	"ama",	0,	0,	1,	0,	0},
	{"Evade",			29,	"ama",	0,	0,	1,	0,	1},
	{"Fend",			30,	"ama",	0,	0,	0,	0,	0},
	{"Freezing Arrow",	31,	"ama",	0,	0,	0,	0,	0},
	{"Valkyrie",		32,	"ama",	0,	0,	1,	1,	0},
	{"Pierce",			33,	"ama",	0,	0,	1,	1,	1},
	{"Lightning Strike",	34,	"ama",	0,	0,	0,	0,	0},
	{"Lightning Fury",	35,	"ama",	0,	0,	0,	0,	0},
	{"Fire Bolt",		36,	"sor",	0,	0,	0,	0,	0},
	{"Warmth",			37,	"sor",	0,	0,	1,	1,	1},
	{"Charged Bolt",	38,	"sor",	0,	0,	0,	0,	0},
	{"Ice Bolt",		39,	"sor",	0,	0,	0,	0,	0},
	{"Frozen Armor",	40,	"sor",	0,	0,	1,	1,	0},
	{"Inferno",			41,	"sor",	0,	0,	0,	0,	0},
	{"Static Field",	42,	"sor",	0,	0,	1,	0,	0},
	{"Telekinesis",		43,	"sor",	0,	0,	1,	1,	0},
	{"Frost Nova",		44,	"sor",	0,	0,	1,	0,	0},
	{"Ice Blast",		45,	"sor",	0,	0,	0,	0,	0},
	{"Blaze",			46,	"sor",	0,	0,	1,	0,	0},
	{"Fire Ball",		47,	"sor",	0,	0,	0,	0,	0},
	{"Nova",			48,	"sor",	0,	0,	1,	0,	0},
	{"Lightning",		49,	"sor",	0,	0,	0,	0,	0},
	{"Shiver Armor",	50,	"sor",	0,	0,	1,	1,	0},
	{"Fire Wall",		51,	"sor",	0,	35,	1,	0,	0},
	{"Enchant",			52,	"sor",	0,	0,	1,	1,	0},
	{"Chain Lightning",	53,	"sor",	0,	0,	0,	0,	0},
	{"Teleport",		54,	"sor",	0,	0,	1,	0,	0},
	{"Glacial Spike",	55,	"sor",	0,	0,	0,	0,	0},
	{"Meteor",			56,	"sor",	0,	30,	1,	0,	0},
	{"Thunder Storm",	57,	"sor",	0,	0,	1,	0,	0},
	{"Energy Shield",	58,	"sor",	0,	0,	1,	1,	0},
	{"Blizzard",		59,	"sor",	0,	45,	1,	0,	0},
	{"Chilling Armor",	60,	"sor",	0,	0,	1,	1,	0},
	{"Fire Mastery",	61,	"sor",	0,	0,	1,	0,	1},
	{"Hydra",			62,	"sor",	0,	50,	1,	0,	0},
	{"Lightning Mastery",	63,	"sor",	0,	0,	1,	0,	1},
	{"Frozen Orb",		64,	"sor",	0,	25,	0,	0,	0},
	{"Cold Mastery",	65,	"sor",	0,	0,	1,	0,	1},
	{"Amplify Damage",	66,	"nec",	0,	0,	1,	0,	0},
	{"Teeth",			67,	"nec",	0,	0,	0,	0,	0},
	{"Bone Armor",		68,	"nec",	0,	0,	1,	1,	0},
	{"Skeleton Mastery",	69,	"nec",	0,	0,	1,	0,	1},
	{"Raise Skeleton",	70,	"nec",	0,	0,	1,	0,	0},
	{"Dim Vision",		71,	"nec",	0,	0,	1,	0,	0},
	{"Weaken",			72,	"nec",	0,	0,	1,	0,	0},
	{"Poison Dagger",	73,	"nec",	0,	0,	0,	0,	0},
	{"Corpse Explosion",	74,	"nec",	0,	0,	1,	0,	0},
	{"Clay Golem",		75,	"nec",	0,	0,	1,	1,	0},
	{"Iron Maiden",		76,	"nec",	0,	0,	1,	0,	0},
	{"Terror",			77,	"nec",	0,	0,	1,	0,	0},
	{"Bone Wall",		78,	"nec",	0,	0,	1,	0,	0},
	{"Golem Mastery",	79,	"nec",	0,	0,	1,	0,	1},
	{"Raise Skeletal Mage",	80,	"nec",	0,	0,	1,	0,	0},
	{"Confuse",			81,	"nec",	0,	0,	1,	0,	0},
	{"Life Tap",		82,	"nec",	0,	0,	1,	0,	0},
	{"Poison Explosion",	83,	"nec",	0,	0,	1,	0,	0},
	{"Bone Spear",		84,	"nec",	0,	0,	0,	0,	0},
	{"BloodGolem",		85,	"nec",	0,	0,	1,	1,	0},
	{"Attract",			86,	"nec",	0,	0,	1,	0,	0},
	{"Decrepify",		87,	"nec",	0,	0,	1,	0,	0},
	{"Bone Prison",		88,	"nec",	0,	0,	1,	0,	0},
	{"Summon Resist",	89,	"nec",	0,	0,	1,	0,	1},
	{"IronGolem",		90,	"nec",	0,	0,	1,	1,	0},
	{"Lower Resist",	91,	"nec",	0,	0,	1,	0,	0},
	{"Poison Nova",		92,	"nec",	0,	0,	1,	0,	0},
	{"Bone Spirit",		93,	"nec",	0,	0,	0,	0,	0},
	{"FireGolem",		94,	"nec",	0,	0,	1,	1,	0},
	{"Revive",			95,	"nec",	0,	0,	1,	0,	0},
	{"Sacrifice",		96,	"pal",	0,	0,	0,	0,	0},
	{"Smite",			97,	"pal",	0,	0,	0,	0,	0},
	{"Might",			98,	"pal",	1,	0,	1,	1,	0},
	{"Prayer",			99,	"pal",	1,	0,	1,	1,	0},
	{"Resist Fire",		100,	"pal",	1,	0,	1,	1,	0},
	{"Holy Bolt",		101,	"pal",	0,	0,	0,	0,	0},
	{"Holy Fire",		102,	"pal",	1,	0,	1,	1,	0},
	{"Thorns",			103,	"pal",	1,	0,	1,	1,	0},
	{"Defiance",		104,	"pal",	1,	0,	1,	1,	0},
	{"Resist Cold",		105,	"pal",	1,	0,	1,	1,	0},
	{"Zeal",			106,	"pal",	0,	0,	0,	0,	0},
	{"Charge",			107,	"pal",	0,	0,	0,	0,	0},
	{"Blessed Aim",		108,	"pal",	1,	0,	1,	1,	0},
	{"Cleansing",		109,	"pal",	1,	0,	1,	1,	0},
	{"Resist Lightning",	110,	"pal",	1,	0,	1,	1,	0},
	{"Vengeance",		111,	"pal",	0,	0,	0,	0,	0},
	{"Blessed Hammer",	112,	"pal",	0,	0,	0,	0,	0},
	{"Concentration",	113,	"pal",	1,	0,	1,	1,	0},
	{"Holy Freeze",		114,	"pal",	1,	0,	1,	1,	0},
	{"Vigor",		115,	"pal",	1,	0,	1,	1,	0},
	{"Conversion",	116,	"pal",	0,	0,	0,	0,	0},
	{"Holy Shield",	117,	"pal",	0,	0,	1,	1,	0},
	{"Holy Shock",	118,	"pal",	1,	0,	1,	1,	0},
	{"Sanctuary",	119,	"pal",	1,	0,	1,	1,	0},
	{"Meditation",	120,	"pal",	1,	0,	1,	1,	0},
	{"Fist of the Heavens",	121,	"pal",	0,	25,	0,	0,	0},
	{"Fanaticism",	122,	"pal",	1,	0,	1,	1,	0},
	{"Conviction",	123,	"pal",	1,	0,	1,	1,	0},
	{"Redemption",	124,	"pal",	1,	0,	1,	1,	0},
	{"Salvation",	125,	"pal",	1,	0,	1,	1,	0},
	{"Bash",		126,	"bar",	0,	0,	0,	0,	0},
	{"Sword Mastery",	127,	"bar",	0,	0,	1,	0,	1},
	{"Axe Mastery",	128,	"bar",	0,	0,	1,	0,	1},
	{"Mace Mastery",	129,	"bar",	0,	0,	1,	0,	1},
	{"Howl",		130,	"bar",	0,	0,	1,	0,	0},
	{"Find Potion",	131,	"bar",	0,	0,	1,	0,	0},
	{"Leap",		132,	"bar",	0,	0,	0,	0,	0},
	{"Double Swing",	133,	"bar",	0,	0,	0,	0,	0},
	{"Pole Arm Mastery",	134,	"bar",	0,	0,	1,	0,	1},
	{"Throwing Mastery",	135,	"bar",	0,	0,	1,	0,	1},
	{"Spear Mastery",	136,	"bar",	0,	0,	1,	0,	1},
	{"Taunt",			137,	"bar",	0,	0,	1,	0,	0},
	{"Shout",			138,	"bar",	0,	0,	1,	0,	0},
	{"Stun",			139,	"bar",	0,	0,	0,	0,	0},
	{"Double Throw",	140,	"bar",	0,	0,	0,	0,	0},
	{"Increased Stamina",	141,	"bar",	0,	0,	1,	0,	1},
	{"Find Item",	142,	"bar",	0,	0,	1,	0,	0},
	{"Leap Attack",	143,	"bar",	0,	0,	0,	0,	0},
	{"Concentrate",	144,	"bar",	0,	0,	0,	0,	0},
	{"Iron Skin",	145,	"bar",	0,	0,	1,	0,	1},
	{"Battle Cry",	146,	"bar",	0,	0,	1,	0,	0},
	{"Frenzy",		147,	"bar",	0,	0,	0,	0,	0},
	{"Increased Speed",	148,	"bar",	0,	0,	1,	0,	1},
	{"Battle Orders",	149,	"bar",	0,	0,	1,	0,	0},
	{"Grim Ward",		150,	"bar",	0,	0,	1,	0,	0},
	{"Whirlwind",		151,	"bar",	0,	0,	0,	0,	0},
	{"Berserk",			152,	"bar",	0,	0,	0,	0,	0},
	{"Natural Resistance",	153,	"bar",	0,	0,	1,	0,	1},
	{"War Cry",			154,	"bar",	0,	0,	1,	0,	0},
	{"Battle Command",	155,	"bar",	0,	0,	1,	0,	0},
// BIG BIG OFFSET HERE 
	{"Scroll of Townportal",	219,	"all",	0,	0,	0,	0,	0},
	{"Book of Townportal",	220,	"all",	0,	0,	0,	0,	0},
	{"Raven",			221,	"dru",	0,	0,	1,	1,	0},
	{"Poison Creeper",	222,	"dru",	0,	0,	1,	1,	0},
	{"Wearwolf",		223,	"dru",	0,	25,	1,	1,	0},
	{"Shape Shifting",	224,	"dru",	0,	0,	0,	0,	1},
	{"Firestorm",		225,	"dru",	0,	15,	0,	0,	0},
	{"Oak Sage",		226,	"dru",	0,	0,	1,	1,	0},
	{"Summon Spirit Wolf",	227,	"dru",	0,	0,	1,	1,	0},
	{"Wearbear",		228,	"dru",	0,	25,	1,	1,	0},
	{"Molten Boulder",	229,	"dru",	0,	50,	0,	0,	0},
	{"Arctic Blast",	230,	"dru",	0,	0,	0,	0,	0},
	{"Carrion Vine",	231,	"dru",	0,	0,	1,	1,	0},
	{"Feral Rage",		232,	"dru",	0,	0,	0,	0,	0},
	{"Maul",			233,	"dru",	0,	0,	0,	0,	0},
	{"Fissure",			234,	"dru",	0,	50,	1,	0,	0},
	{"Cyclone Armor",	235,	"dru",	0,	0,	1,	1,	0},
	{"Heart of Wolverine",	236,	"dru",	0,	0,	1,	1,	0},
	{"Summon Dire Wolf",	237,	"dru",	0,	0,	1,	1,	0},
	{"Rabies",		238,	"dru",	0,	0,	0,	0,	0},
	{"Fire Claws",	239,	"dru",	0,	0,	0,	0,	0},
	{"Twister",		240,	"dru",	0,	0,	0,	0,	0},
	{"Solar Creeper",	241,	"dru",	0,	0,	1,	1,	0},
	{"Hunger",		242,	"dru",	0,	0,	0,	0,	0},
	{"Shock Wave",	243,	"dru",	0,	0,	0,	0,	0},
	{"Volcano",		244,	"dru",	0,	100,	1,	0,	0},
	{"Tornado",		245,	"dru",	0,	0,	0,	0,	0},
	{"Spirit of barbs",	246,	"dru",	0,	0,	1,	1,	0},
	{"Summon Grizzly",	247,	"dru",	0,	0,	1,	1,	0},
	{"Fury",		248,	"dru",	0,	0,	0,	0,	0},
	{"Armageddon",	249,	"dru",	0,	150,	1,	0,	0},
	{"Hurricane",	250,	"dru",	0,	150,	1,	0,	0},
	{"Fire Blast",	251,	"ass",	0,	0,	0,	0,	0},
	{"Claw Mastery",	252,	"ass",	0,	0,	0,	0,	1},
	{"Psychic Hammer",	253,	"ass",	0,	0,	1,	0,	0},
	{"Tiger Strike",	254,	"ass",	0,	0,	0,	0,	0},
	{"Dragon Talon",	255,	"ass",	0,	0,	0,	0,	0},
	{"Shock Web",		256,	"ass",	0,	0,	0,	0,	0},
	{"Blade Sentinel",	257,	"ass",	0,	50,	0,	0,	0},
	{"Burst of Speed",	258,	"ass",	0,	0,	1,	1,	0},
	{"Fists of Fire",	259,	"ass",	0,	0,	0,	0,	0},
	{"Dragon Claw",		260,	"ass",	0,	0,	0,	0,	0},
	{"Charged Bolt Sentry",	261,	"ass",	0,	0,	1,	0,	0},
	{"Wake of Fire",	262,	"ass",	0,	0,	1,	0,	0},
	{"Weapon Block",	263,	"ass",	0,	0,	1,	0,	1},
	{"Cloak of Shadows",	264,	"ass",	0,	0,	1,	0,	0},
	{"Cobra Strike",	265,	"ass",	0,	0,	0,	0,	0},
	{"Blade Fury",		266,	"ass",	0,	0,	0,	0,	0},
	{"Fade",			267,	"ass",	0,	0,	1,	1,	0},
	{"Shadow Warrior",	268,	"ass",	0,	0,	1,	1,	0},
	{"Claws of Thunder",	269,	"ass",	0,	0,	0,	0,	0},
	{"Dragon Tail",		270,	"ass",	0,	0,	0,	0,	0},
	{"Lightning Sentry",	271,	"ass",	0,	0,	1,	0,	0},
	{"Wake of Inferno",	272,	"ass",	0,	0,	1,	0,	0},
	{"Mind Blast",		273,	"ass",	0,	0,	1,	0,	0},
	{"Blades of Ice",	274,	"ass",	0,	0,	0,	0,	0},
	{"Dragon Flight",	275,	"ass",	0,	50,	0,	0,	0},
	{"Death Sentry",	276,	"ass",	0,	0,	1,	0,	0},
	{"Blade Shield",	277,	"ass",	0,	0,	1,	1,	0},
	{"Venom",			278,	"ass",	0,	0,	1,	1,	0},
	{"Shadow Master",	279,	"ass",	0,	0,	1,	1,	0},
	{"Phoenix Strike",	280,	"ass",	0,	0,	0,	0,	0}
};

//------------------------------------------------//
// Packet 55 - npc update
//Automatic save healer akara, etc  id
DWORD healer_info(BYTE* aPacket, DWORD aLen)
{
	for (int i = 0; i < HEALER_ARRAY_SIZE; i++)
	{
		if (*(WORD*)(aPacket+5) == healer[i].entityID)
		{
	        if(Debug == DEBUG_DEVEL)
			{
				sprintf(DebugBuffer, "%s id is %.2x", healer[i].name, aPacket[1]);
        		server->GamePrintString(DebugBuffer);
			}
			memcpy(&healer[i].baseID, aPacket+1, 2);
			lastHealer_seen = i;
		}
    }
	return aLen;
}

int get_healer_by_name(char * npcName)
{
	for (int i = 0; i < HEALER_ARRAY_SIZE; i++)
	{
		if (strcmpi(npcName, healer[i].name) == 0)
			return i;
    }
	return HEALER_ARRAY_SIZE;

}

//////////////////////////////////////////////////////////////////////
// player_join
// -------------------------------------------------------------------
// Packet 5b - modified from wanderer
//////////////////////////////////////////////////////////////////////
DWORD player_join(BYTE* aPacket, DWORD aLen)
{
	if ( (aPacket[1] == 0x24) && (aPacket[3] != thisgame->player->PlayerID))
	{
		//Check to see if the master is joining
		if (strcmp ((const char *) leaderName, (const char *) (aPacket + 8)) == 0)
		{
			int index = add_PlayerInfo((aPacket + 8), aPacket[3]);
			leaderId = aPacket[3];
			toFollow = true;
			sprintf(DebugBuffer,"Master c2%sc20(c3%dc0) joined game", playerInGame[index].PlayerName,
				playerInGame[index].PlayerID);

			server->GamePrintInfo(DebugBuffer);
		}
	}
	return aLen;
}

//////////////////////////////////////////////////////////////////////
// skill_switch
// -------------------------------------------------------------------
// Packet 23 - Skill switch update
//////////////////////////////////////////////////////////////////////
WORD left_skill, right_skill;
DWORD skill_selected(BYTE* aPacket, DWORD aLen)
{
   	//------------------------------------------------//
   	// Goto town thingie
	//	Confirmation on switching skill to TP
    if ((stateGotoTown == STATE_GOTO_TOWN_SWITCHING_SKILL) &&
		(aPacket[7]  == 0xdc) && 
		(aPacket[8]  == 0x00) && 
		(aPacket[9]  == 0xff) &&
		(aPacket[10] == 0xff) && 
		(aPacket[11] == 0xff) && 
		(aPacket[12] == 0xff) )
    {
	    castTownPortal(aPacket, aLen);
		return (aLen);
    }
	//print_Packet(aPacket, aLen);
	else if (aPacket[6] == 0x01) // left
	{
		SKILL_IN_CONV(((WORD) (aPacket[7])), left_skill);
        if(Debug == DEBUG_DEVEL)
		{
			sprintf(DebugBuffer, "left skill: %s", game_skills[left_skill].name);
		    server->GamePrintInfo(DebugBuffer);		
		}
	}
	else
	{
		SKILL_IN_CONV(((WORD) (aPacket[7])), right_skill);
        if(Debug == DEBUG_DEVEL)
		{
			sprintf(DebugBuffer, "right skill: %s", game_skills[right_skill].name);
		    server->GamePrintInfo(DebugBuffer);		
		}
	}

	return aLen;
}

//------------------------------------------------//
// Packet 0d - other player info/movement
DWORD player_info(BYTE* aPacket, DWORD aLen)
{
	if ( toFollow && (aPacket[2] == leaderId) )
	{ 
		//sprintf(DebugBuffer, "%d, %d", (WORD) (aPacket[7]), (WORD) (aPacket[9]));
	    //server->GamePrintInfo(DebugBuffer);		
		memcpy(&leaderLoc.x, (aPacket+7), 2);
		memcpy(&leaderLoc.y, (aPacket+9), 2);
	}
	return aLen;
}


//------------------------------------------------//
// Packet 09 05 - cave/level entrances
///////////////////////
DWORD cave_notification(BYTE* aPacket, DWORD aLen)
{
	if (aPacket[1] == 0x05)
	{
        if(Debug == DEBUG_DEVEL)
		{
    		sprintf(DebugBuffer, "Lvl entrance type %d detected.", aPacket[6]);
	    	server->GamePrintInfo(DebugBuffer);
	
		    sprintf(DebugBuffer, "Name: %s", lvl_wrap_data[aPacket[6]].lvlName);
    		server->GamePrintInfo(DebugBuffer);
        }
	}
	return aLen;
}


//------------------------------------------------//
// Packet 10 - cave follow code
DWORD cave_follow(BYTE* aPacket, DWORD aLen)
{
	if ( toFollow && 
		 (aPacket[1] == 0x00) &&	// not sure if this is always 0x00
		 (aPacket[2] == leaderId) &&
		 (aPacket[6] == 0x18) && // seems to be constant
		 (aPacket[7] == 0x05) 
		 )
	{
		//BYTE pPacket[] = {0x04, 0x05, 0, 0, 0, 0, 0, 0, 0};
		saPacket[0] = (BYTE) 0x04; // run to entrance
		saPacket[1] = (BYTE) 0x05;
		saPacket[2] = (BYTE) 0x00;
		saPacket[3] = (BYTE) 0x00;
		saPacket[4] = (BYTE) 0x00;
		saPacket[5] = aPacket[8];
		saPacket[6] = aPacket[9];
		saPacket[7] = aPacket[10];
		saPacket[8] = aPacket[11];
		server->GameSendPacketToServer(saPacket, 9); // run to entrance

		saPacket[0] = 0x13;
		//server->GameSendPacketToServer(saPacket, 9); // use entrance
		// create thread to ensure that there's a delay be we attempt to go into entrance
		DWORD dummy1;
		CreateThread(NULL, 0, SleepThread, &saPacket, 0, &dummy1);
	}
	return aLen;
}


//------------------------------------------------//
// Packet 26 01 - chat msg
///////////////////////
// text chat msg - check for leader command
DWORD incoming_chat_msg(BYTE* aPacket, DWORD aLen)
{	// 01 - NORMAL, 02 WHISPER
	if ( ( (aPacket[1] == 0x01)|| (aPacket[1] == 0x02)) && (leaderPos >= 0) )
	{
		checkLeaderCmd(aPacket, aLen);
	}
	return aLen;
}


//------------------------------------------------//
// Packet 5a 
DWORD player_notification(BYTE* aPacket, DWORD aLen)
{
	//------------------------------------------------//
	// Packet 5a 03 - player leaves game notification
	if (aPacket[1] == 0x03)
	{ 
		int result = removePlayerInfo(aPacket, aLen);
		if(result < 0)
		{
			sprintf(DebugBuffer, "remove Player ERROR");
			server->GamePrintError(DebugBuffer);
		}
		else if(Debug == DEBUG_DEVEL)
		{
			sprintf(DebugBuffer, "removed %s.", aPacket+8);
			server->GamePrintInfo(DebugBuffer);
		}
		return aLen;
	}
	//------------------------------------------------//
	// 5a 06 death
	else if ( autoResurr && 
			(aPacket[1] == 0x06) &&
			(aPacket[2] == 0x04) )
	{
		// someone died, check name to see if its the bot
		if (strcmpi((const char*)aPacket+8, thisgame->player->PlayerName) == 0)
		{
			toFollow = false;
			justDied = true;
			if(Debug == DEBUG_DEVEL)
			{
				server->GamePrintInfo("Bot died - resurr in 5 sec");
			}				
			DWORD dummy1;
			CreateThread(NULL, 0, ResurrThread, NULL, 0, &dummy1);
			return aLen;
		}
	}
	//------------------------------------------------//
	// 5a 07 party - from wanderer
	//Automaticly join masters party invite
	else if ( (aPacket[1] == 0x07) &&
			(aPacket[2] == 0x02) &&
			(aPacket[3] == leaderId) &&
			(aPacket[7] == 0x05) &&
			StateInParty == 0 )
	{
		BYTE pPacket[] = {0x5e, 0x08, 0, 0, 0, 0};
		pPacket[2] = aPacket[3];
		server->GameSendPacketToServer(pPacket, 6);
		StateInParty = 1;
	}
	return aLen;
}



//------------------------------------------------//
// Packet 59 - Player info update
///////////////////////
// New Player encountered - store information
DWORD new_player(BYTE* aPacket, DWORD aLen)
{
	int result = addPlayerInfo(aPacket, aLen);
	if(Debug == DEBUG_DEVEL && result < 0)
	{
		sprintf(DebugBuffer,"add Player ERROR");
		server->GamePrintError(DebugBuffer);
	}
	return aLen;
}


//------------------------------------------------//
// Packet 82 - TP data
DWORD townportal_info(BYTE* aPacket, DWORD aLen)
{
	// check tp belongs to leader
	//if (strcmpi((const char*)aPacket+5, playerInGame[leaderPos].PlayerName) == 0)
	if (portal_count == TP_ARRAY_SIZE) // mod bug
		portal_count = 0;

	if (thisgame->player->PlayerLocation == 0x05)
	{
    	sprintf(DebugBuffer, "(wilderness)");			
		portals[portal_count].inTown = false;
	}
	else
	{
    	sprintf(DebugBuffer, "(town)");			
		portals[portal_count].inTown = true;
	}

	if(Debug == DEBUG_DEVEL)
    {
    	sprintf(DebugBuffer, "%sPortal Detected: c2%sc0, %d", DebugBuffer, aPacket+5, portal_count);			
		server->GamePrintInfo(DebugBuffer);
    }
	memcpy(portals[portal_count].playerName, aPacket+5, 16);
	memcpy(portals[portal_count].portalIdA,  aPacket+21, 4); // IdA is the one to use when sending p13
	memcpy(portals[portal_count].portalIdB,  aPacket+25, 4);
	portal_count = ((portal_count+1) % TP_ARRAY_SIZE);

	// for now, until i make sure above works
	//if ( (thisgame->player->PlayerLocation == 0x01) && (retStored == false) &&
	//		(aPacket[1] == thisgame->player->PlayerID))
	//{
	//	retStored = true;
	//	myPortalRetId[0] = aPacket[25];
	//	myPortalRetId[1] = aPacket[26];
	//	myPortalRetId[2] = aPacket[27];
	//	myPortalRetId[3] = aPacket[28];
	//}
	return aLen;
}

int get_tp_by_name(char* ownerName)
{
	int index = (portal_count-1) % TP_ARRAY_SIZE;
	for (int i = 0; i < TP_ARRAY_SIZE; i++, index = (index-1) % TP_ARRAY_SIZE)
	{
		if (strcmpi(portals[index].playerName, ownerName) == 0)
			return index;
	}
	// can't find it, what do i return?
	return TP_ARRAY_SIZE;
}

//////////////////////////////////////////////////////////////////////
// monster_moving
// -------------------------------------------------------------------
// Packet 67 - monster/entity moving
//////////////////////////////////////////////////////////////////////
DWORD monster_moving(BYTE* aPacket, DWORD aLen)
{
	if ( !toAttack )
		return aLen;
	if ( (aPacket[0] == 0x67) )  // note can't attack in town.. or wrong entity
	{
		if ( (autoAttack == STATE_ATK_AGGRESSIVE)) 
		{
			OverheadMsg("aggressive");
			BYTE p[] = {0x09, 0x01, 0, 0, 0, 0, 0, 0, 0};
			if (attackSkill == STATE_SKILL_LEFT)
				p[0] = 0x09;
			else
				p[0] = 0x10;
			memcpy (p + 5, aPacket+1, 4);
			server->GameSendPacketToServer (p, 9);
		}
	}
	return aLen;
}

//////////////////////////////////////////////////////////////////////
// monster_approaching
// -------------------------------------------------------------------
// Packet 68 - monster approaching/attacking target
//////////////////////////////////////////////////////////////////////
DWORD monster_approaching(BYTE* aPacket, DWORD aLen)
{
	if ( !toAttack )
		return aLen;
	// auto locate target attacking me and (counter)attack 
	if ( (aPacket[11] == thisgame->player->PlayerID) || (aPacket[11] == leaderId) )
	{
		if ( (autoAttack == STATE_ATK_DEFENSIVE) || (autoAttack == STATE_ATK_AGGRESSIVE)) 
		{
			OverheadMsg("auto");
			BYTE p[] = {0x09, 0x01, 0, 0, 0, 0, 0, 0, 0};
			switch(attackSkill)
			{
			case STATE_SKILL_LEFT:
				p[0] = 0x06;
				break;
			case STATE_SKILL_SHIFT_LEFT:
				p[0] = 0x07;
				break;
			case STATE_SKILL_RIGHT:
				p[0] = 0x0d;
				break;
			case STATE_SKILL_SHIFT_RIGHT:
				p[0] = 0x0e;
				break;
			}
			memcpy (p + 5, aPacket+1, 4);
			server->GameSendPacketToServer (p, 9);
		}
	}
	return aLen;
}
//////////////////////////////////////////////////////////////////////
// player_target_attack
// -------------------------------------------------------------------
// Packet 4c - leader use skill (target) - from wanderer
//////////////////////////////////////////////////////////////////////
DWORD player_target_attack(BYTE* aPacket, DWORD aLen)
{
	//Automaticly attack whatever the master is attacking 
	//if aggressive mode is set and if following
	if ( toFollow && toAttack && (aPacket[2] == leaderId))
	{
		// 06(click unitL) -> 09(hold unitL), 		
		// 07(shift unitL) -> 0A (shift hold unit L), 
		// 0d(click unitR) -> 10 (hold unitR),
		// oe(shift unitR) -> 11 (shift hold unit R)
		BYTE p[] = {0x09, 0x01, 0, 0, 0, 0, 0, 0, 0};
		//memcpy (p + 1, &thisgame->player->PlayerID, 4);
		switch(attackSkill)
		{
		case STATE_SKILL_LEFT:
			p[0] = 0x06;
			break;
		case STATE_SKILL_SHIFT_LEFT:
			p[0] = 0x07;
			break;
		case STATE_SKILL_RIGHT:
			p[0] = 0x0d;
			break;
		case STATE_SKILL_SHIFT_RIGHT:
			p[0] = 0x0e;
			break;
		}

		memcpy (p + 5, aPacket+10, 4);
		server->GameSendPacketToServer (p, 9);
        OverheadMsg("aim");
	}
	else if ( toFollow && toAttack && (aPacket[10] == leaderId)) // under attack
	{

	}
	return aLen;
}

//////////////////////////////////////////////////////////////////////
// player_nontarget_attack
// -------------------------------------------------------------------
// Packet 4d - other player use skill (non target)
//////////////////////////////////////////////////////////////////////
DWORD player_nontarget_attack(BYTE* aPacket, DWORD aLen)
{
	//Automaticly attack whereever the master is attacking 
	//if aggressive mode is set and if following
	if ( toFollow && toAttack && (aPacket[2] == leaderId) )
	{ 
		// check for teleport here
		if (aPacket[6] == 0x36 && aPacket[7] == 0x00)
		{
			OverheadMsg("teleport detected");
			// note need to check level
			if ((toTeleport) && (thisgame->player->CharacterClass == CharClassSorceress))
				teleport_to_pos((DWORD*) (aPacket+9));
			else
				run_to_pos((DWORD*) (aPacket+9));
			return aLen;
		}

		// use 05(shiftclickL) -> 08(holdR), 0c(shiftclickR) -> 0f(holdR)
		BYTE attack[5];
		switch(attackSkill)
		{
		case STATE_SKILL_LEFT:
		case STATE_SKILL_SHIFT_LEFT:
			attack[0] = 0x05;
			break;
		case STATE_SKILL_RIGHT:
		case STATE_SKILL_SHIFT_RIGHT:
			attack[0] = 0x0c;
			break;
		}

		memcpy (attack+1, aPacket+9, 2);
		memcpy (attack+3, aPacket+11, 2);
		server->GameSendPacketToServer(attack, 5);
        OverheadMsg("no aim");
	}
	return aLen;
}

//////////////////////////////////////////////////////////////////////
// player_movement
// -------------------------------------------------------------------
// Packet 0F - other player movement 
//////////////////////////////////////////////////////////////////////
DWORD player_movement(BYTE* aPacket, DWORD aLen)
{
	if ( toFollow && (aPacket[2] == leaderId) )
		followLeader(aPacket, aLen);
	return aLen;
}


//////////////////////////////////////////////////////////////////////
// posUpdate
// -------------------------------------------------------------------
// Packet 7f 01 - position update
//////////////////////////////////////////////////////////////////////
DWORD posUpdate(BYTE* aPacket, DWORD aLen)
{
	if ( (aPacket[1] == 0x01) &&
		 (aPacket[4] == leaderId) )
	{
        if(Debug == DEBUG_DEVEL)
		{
    		sprintf(DebugBuffer, "Leader wrapped to %s", lvl_name_data[aPacket[8]].lvlName);
	    	server->GamePrintInfo(DebugBuffer);
			sprintf(DebugBuffer, "last pos %d, %d", leaderLoc.x, leaderLoc.y);
    		server->GamePrintInfo(DebugBuffer);
        }
		// if near wp - how?
		// go to nearest wp location
		WPSTRUCT *destwp = getWPbyName(lvl_name_data[aPacket[8]].lvlName);
		if (destwp == NULL) 
		{
			// expand here - to follow through tp or red portals
	        if(Debug == DEBUG_USER || Debug == DEBUG_DEVEL)
			{
				sprintf(DebugBuffer, "No Dest wp or Master used tp. am at %d, %d", thisgame->player->PlayerPositionX, thisgame->player->PlayerPositionY);
	    		server->GamePrintError(DebugBuffer);
			}
			if ((abs(last_gw.pos.x - thisgame->player->PlayerPositionX) < 15) &&
				(abs(last_gw.pos.y - thisgame->player->PlayerPositionY) < 15) )
			{
				sprintf(DebugBuffer, "Gateway is near by: %d, %d", last_gw.pos.x, last_gw.pos.y);
				server->GamePrintInfo(DebugBuffer);
				InteractWithEntity(2, last_gw.entityID);
			}
			return aLen;
		}
        // send packet to use wp
		if ((abs(wp.pos.x - thisgame->player->PlayerPositionX) < 15) &&
			(abs(wp.pos.y - thisgame->player->PlayerPositionY) < 15) )

		{
	        if(Debug == DEBUG_USER || Debug == DEBUG_DEVEL)
			{
				sprintf(DebugBuffer, "WP is near by");
				server->GamePrintInfo(DebugBuffer);
			}
			TakeWayPoint(wp.entityID, destwp->wpNum);
		}
		else
		{
			// expand here, look for wp and run to it
			if(Debug == DEBUG_USER || Debug == DEBUG_DEVEL)
			{
				sprintf(DebugBuffer, "Where is the wp?? am at %d, %d", thisgame->player->PlayerPositionX, thisgame->player->PlayerPositionY);
				server->GamePrintError(DebugBuffer);
			}
			if ((abs(last_gw.pos.x - thisgame->player->PlayerPositionX) < 15) &&
				(abs(last_gw.pos.y - thisgame->player->PlayerPositionY) < 15) )
			{
				sprintf(DebugBuffer, "Gateway is near by: %d, %d", last_gw.pos.x, last_gw.pos.y);
				server->GamePrintInfo(DebugBuffer);
				InteractWithEntity(2, last_gw.entityID);
			}
		}
	}
	return aLen;
}

//////////////////////////////////////////////////////////////////////
// client_walk_update
// -------------------------------------------------------------------
// Client side walk update
//////////////////////////////////////////////////////////////////////
DWORD client_walk_update(BYTE* aPacket, DWORD aLen)
{	
	if (toFollow)
	{
		BYTE upd[16];
        upd[0] = 0x0f;
        upd[1] = 0;
        upd[6] = 0x17;
        upd[11] = 0;
		memcpy (upd + 2, &thisgame->player->PlayerID, 4);
		memcpy (upd + 7, aPacket + 1, 4);
		memcpy (upd + 12, &thisgame->player->PlayerPositionX, 2);
		memcpy (upd + 14, &thisgame->player->PlayerPositionY, 2);
        server->GameSendPacketToGame (upd, 16);
    }
    return aLen;
}

//////////////////////////////////////////////////////////////////////
// deny_client_sync
// -------------------------------------------------------------------
// block client side sync packet
//////////////////////////////////////////////////////////////////////
DWORD deny_client_sync(BYTE* aPacket, DWORD aLen)
{
	if( blockSync && toFollow)
		return 0;

	return aLen;
}

//////////////////////////////////////////////////////////////////////
// OnGameJoin
// -------------------------------------------------------------------
// Executes when joining a game, and if loading the module while 
// inside a game.
//////////////////////////////////////////////////////////////////////
VOID EXPORT OnGameJoin(THISGAMESTRUCT* game)
{
	thisgame = game;
	for (int i = 0; i < MAX_PLAYER_IN_GAME; i++)
		playerInGame[i].InUse = false;
	toFollow = false;
    leaderId = 0;
	leaderPos = -1;
	StateInParty = 0;
	return;
}

//////////////////////////////////////////////////////////////////////
// OnGameLeave
// -------------------------------------------------------------------
// Executes when leaving a game.
//////////////////////////////////////////////////////////////////////
VOID EXPORT OnGameLeave(THISGAMESTRUCT* thisgame)
{
	for (int i = 0; i < MAX_PLAYER_IN_GAME; i++)
		playerInGame[i].InUse = false;
	leaderId = 0;
	leaderPos = -1;
	StateInParty = 0;
	toFollow = false;
	return;
}

//////////////////////////////////////////////////////////////////////
// OnGameCommandStart
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////

BOOL PRIVATE OnGameCommandStart(char** argv, int argc)
{
	if (argc > 2) 
	{
        if (strcmpi(argv[2], "help") == 0)
        {
    		sprintf(DebugBuffer,".follow start c3idc0 - where id is the leader's in game ID");
        	server->GamePrintString(DebugBuffer);
    		sprintf(DebugBuffer,"use .follow info to obtain the list of possible ID's");
        	server->GamePrintString(DebugBuffer);
            return false;
        }
        else if (atoi(argv[2])) // a number
		{
    		sprintf(DebugBuffer,"Follow Started - c3%sc0", argv[2]);
	    	server->GamePrintString(DebugBuffer);
		    leaderId = atoi(argv[2]);
		}
		else // not a number
        {
			memcpy(leaderName, argv[2], LEN_CHARNAME);
    		sprintf(DebugBuffer,"Follow Started - c3%sc0", leaderName);
	    	server->GamePrintString(DebugBuffer);
			leaderId = 0;	// temp reset
        }
	}
	else if (leaderId > 0)
	{
		sprintf(DebugBuffer,"Follow Started - c3%dc0", leaderId);
		server->GamePrintString(DebugBuffer);
	}
	else
	{
		sprintf(DebugBuffer,"No leader id defined");
		server->GamePrintString(DebugBuffer);
		sprintf(DebugBuffer,".follow start id");
		server->GamePrintString(DebugBuffer);
		return false;
	}
	toFollow = true;
	for (int i = 0; i < MAX_PLAYER_IN_GAME; i++)
	{
		if (leaderId > 0 && playerInGame[i].PlayerID == leaderId)
		{
			leaderPos = i;
			sprintf(DebugBuffer,"leader is c2%sc0", playerInGame[i].PlayerName);
			server->GamePrintInfo(DebugBuffer);
			break;
		}
		// find player already in table
		else if ((playerInGame[i].InUse == true) && 
			(strcmpi(leaderName, playerInGame[i].PlayerName)==0)) // check name
		{
			leaderPos = i;
			leaderId = playerInGame[i].PlayerID;
			sprintf(DebugBuffer,"leader is c2%sc0", playerInGame[i].PlayerName);
			server->GamePrintInfo(DebugBuffer);
			break;
		}
	}
	return true;
}
//////////////////////////////////////////////////////////////////////
// OnGameCommandStop
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////

BOOL PRIVATE OnGameCommandStop(char** argv, int argc)
{
    if (argc > 2)
    {
        return false;
    }
    else
    {
    	sprintf(DebugBuffer,"Follow Stopped");
	    server->GamePrintString(DebugBuffer);
    }
	toFollow = false;
	return true;


}

//////////////////////////////////////////////////////////////////////
// OnGameCommandList
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandList(char** argv, int argc)
{
	int count = 0;
	for(int i = 0; i < MAX_PLAYER_IN_GAME; i++)
	{
		if (playerInGame[i].InUse == true)
		{
			sprintf(DebugBuffer,"Player c3%dc0, c2%sc0", playerInGame[i].PlayerID, playerInGame[i].PlayerName);
			server->GamePrintString(DebugBuffer);
			count++;
		}
	}
	sprintf(DebugBuffer,"%d player stored", count);
	server->GamePrintString(DebugBuffer);

	return true;
}

//////////////////////////////////////////////////////////////////////
// OnGameCommandReload
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandReload(char** argv, int argc)
{
	readInitFile();
	OnGameCommandStatus(argv, argc);
	return true;
}


//////////////////////////////////////////////////////////////////////
// OnGameCommandStatus
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandStatus(char** argv, int argc)
{
    if (argc > 2)
        return false;

	// show player stored
	// OnGameCommandList(argv, argc);
	// show current leader

	sprintf(DebugBuffer,"My Id is c2%dc0", thisgame->player->PlayerID);
	server->GamePrintInfo(DebugBuffer);

	if (leaderPos >= 0)
		sprintf(DebugBuffer,"Leader is c2%sc0(c3%dc0)", playerInGame[leaderPos].PlayerName, playerInGame[leaderPos].PlayerID);
	else
		sprintf(DebugBuffer,"No Leader defined yet");

	server->GamePrintInfo(DebugBuffer);

	//------------------------------------------------//
	// show current states
	if ( (stateGotoTown == STATE_GOTO_TOWN_IDLE) )
		sprintf(DebugBuffer,"STATE_GOTO_TOWN%s", "IDLE");
	else if ( (stateGotoTown == STATE_GOTO_TOWN_SWITCHING_SKILL) )
		sprintf(DebugBuffer,"STATE_GOTO_TOWN%s", "SWITCHING_SKILL");
	else if ( (stateGotoTown == STATE_GOTO_TOWN_USING_SKILL) )
		sprintf(DebugBuffer,"STATE_GOTO_TOWN%s", "USING_SKILL");

	server->GamePrintInfo(DebugBuffer);

	//------------------------------------------------//
	if (toFollow) 
		sprintf(DebugBuffer,"follow is c2ONc0");
	else
		sprintf(DebugBuffer,"follow is c1OFFc0");

	server->GamePrintInfo(DebugBuffer);

	//------------------------------------------------//
	if (toAttack) 
	{
		sprintf(DebugBuffer,"attack is c2ONc0");
		server->GamePrintInfo(DebugBuffer);

		//------------------------------------------------//
		if (autoAttack)
			sprintf(DebugBuffer,"  auto attack is c2ONc0");
		else
			sprintf(DebugBuffer,"  auto attack is c1OFFc0");

		server->GamePrintInfo(DebugBuffer);

		//------------------------------------------------//
		if (shiftState) 
			sprintf(DebugBuffer,"  shift(attack) is c2ONc0");
		else
			sprintf(DebugBuffer,"  shift(attack) is c1OFFc0");

		server->GamePrintInfo(DebugBuffer);

		//------------------------------------------------//
		switch(attackSkill)
		{
		case STATE_SKILL_LEFT:
			sprintf(DebugBuffer,"  c3leftc0 attack");
			break;
		case STATE_SKILL_SHIFT_LEFT:
			sprintf(DebugBuffer,"  c3shift leftc0 attack");
			break;
		case STATE_SKILL_RIGHT:
			sprintf(DebugBuffer,"  c3rightc0 attack");
			break;
		case STATE_SKILL_SHIFT_RIGHT:
			sprintf(DebugBuffer,"  c3shift rightc0 attack");
			break;
		}
		server->GamePrintInfo(DebugBuffer);

		//------------------------------------------------//
		sprintf(DebugBuffer, "left skill: %s", game_skills[left_skill].name);
		server->GamePrintInfo(DebugBuffer);		
		sprintf(DebugBuffer, "right skill: %s", game_skills[right_skill].name);
		server->GamePrintInfo(DebugBuffer);		

	}
	else
	{
		sprintf(DebugBuffer,"attack is c1OFFc0");
		server->GamePrintInfo(DebugBuffer);
	}

	//------------------------------------------------//
	if (blockSync) 
		sprintf(DebugBuffer,"sync block is c2ONc0");
	else
		sprintf(DebugBuffer,"sync block is c1OFFc0");

	server->GamePrintInfo(DebugBuffer);

	//------------------------------------------------//
	if (toNotify) 
		sprintf(DebugBuffer,"notify is c2ONc0");
	else
		sprintf(DebugBuffer,"notify is c1OFFc0");

	server->GamePrintInfo(DebugBuffer);

	//------------------------------------------------//
	if (toTeleport) 
		sprintf(DebugBuffer,"teleport follow is c2ONc0");
	else
		sprintf(DebugBuffer,"teleport follow is c1OFFc0");

	server->GamePrintInfo(DebugBuffer);

	return true;
}

//////////////////////////////////////////////////////////////////////
// OnGameCommandNotify
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandNotify(char** argv, int argc)
{
    if (argc > 2)
    {
        return false;
    }
    else if(toNotify)
	{
		server->GamePrintInfo("Overhead Notify disabled");
		toNotify = false;
	} else {
		server->GamePrintInfo("Overhead Notify enabled");
		toNotify = true;
	}
	return true;
}


//////////////////////////////////////////////////////////////////////
// OnGameCommandAttack
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandAttack(char** argv, int argc)
{
    if (argc > 2)
    {
        return false;
    }
    else if(toAttack)
	{
		server->GamePrintInfo("Attacking disabled");
		toAttack = false;
	} else {
		server->GamePrintInfo("Attacking enabled");
		toAttack = true;
	}
	return true;
}

//////////////////////////////////////////////////////////////////////
// OnGameCommandBlock
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandBlock(char** argv, int argc)
{
	if (argc > 2)
		return false;

	blockSync = !blockSync;
	if (blockSync) 
		sprintf(DebugBuffer,"sync block is c2ONc0");
	else
		sprintf(DebugBuffer,"sync block is c1OFFc0");

	server->GamePrintString(DebugBuffer);

	return true;
}

//////////////////////////////////////////////////////////////////////
// OnGameCommandShift
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandShift(char** argv, int argc)
{
	if (argc > 2)
		return false;

	shiftState = !shiftState;
	if (shiftState) 
		sprintf(DebugBuffer,"shift(attack) is c2ONc0");
	else
		sprintf(DebugBuffer,"shift(attack) is c1OFFc0");

	server->GamePrintString(DebugBuffer);

	return true;
}

//////////////////////////////////////////////////////////////////////
// OnGameCommandSave
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandSave(char** argv, int argc)
{
	set_setting(INI_SECT_STATE, INI_ATTK_STATE, toAttack);
	set_setting(INI_SECT_STATE, INI_SYNC_STATE, blockSync);
	set_setting(INI_SECT_STATE, INI_SHIFT_STATE, shiftState);
	set_setting(INI_SECT_STATE, INI_AUTO_ATTK, autoAttack);
	set_setting(INI_SECT_STATE, INI_OVERHEAD_MSG, toNotify);
	set_setting(INI_SECT_STATE, INI_TELE_STATE, toTeleport);
	server->GamePrintInfo("Saved to c4follow.inic0");
	return true;
}

//////////////////////////////////////////////////////////////////////
// OnGameCommandAuto
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
BOOL PRIVATE OnGameCommandAuto(char** argv, int argc)
{
	if (argc != 3)
		return false;

	if (strcmpi(argv[2], DEFENSIVE) == 0)
	{
		autoAttack = STATE_ATK_DEFENSIVE;
		sprintf(DebugBuffer,"Auto Attack is c2ONc0");
	}
	else if (strcmpi(argv[2], NORMAL) == 0)
	{
		autoAttack = STATE_ATK_NORMAL;
		sprintf(DebugBuffer,"Auto Attack is c1OFFc0");
	}
	else
	{
		return false;
	}
	server->GamePrintInfo(DebugBuffer);

	return true;
}


//////////////////////////////////////////////////////////////////////
// readInitFile
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
void readInitFile()
{
	cmd_gofield = get_setting(INI_SECT_CMD, INI_GO, LEADERCMD_GOFIELD);
	cmd_rettown = get_setting(INI_SECT_CMD, INI_TOWN, LEADERCMD_RETTOWN);
	cmd_stay	= get_setting(INI_SECT_CMD, INI_STAY, LEADERCMD_STAY);
	cmd_follow	= get_setting(INI_SECT_CMD, INI_FOLLOW, LEADERCMD_FOLLOW);
	cmd_attack	= get_setting(INI_SECT_CMD, INI_ATTK, LEADERCMD_ATTACK);
	cmd_taketp	= get_setting(INI_SECT_CMD, INI_TP, LEADERCMD_TAKETP);
	cmd_switch	= get_setting(INI_SECT_CMD, INI_SWITCH, LEADERCMD_SWITCH);
	cmd_waypoint = get_setting(INI_SECT_CMD, INI_WP, LEADERCMD_WAYPOINT);
	cmd_weaponswitch = get_setting(INI_SECT_CMD, INI_WS, LEADERCMD_WEAPONSWITCH);
	cmd_heal = get_setting(INI_SECT_CMD, INI_HEAL, LEADERCMD_GETHEAL);

	char *r = get_setting(INI_SECT_STATE, INI_ATTK_STATE, "OFF");
	if (strcmpi(r, ON) == 0)
		toAttack = true;
	else
		toAttack = false;
	delete r;

	r = get_setting(INI_SECT_STATE, INI_SYNC_STATE, "OFF");
	if (strcmpi(r, ON) == 0)
		blockSync = true;
	else
		blockSync = false;

	r = get_setting(INI_SECT_STATE, INI_SHIFT_STATE, "OFF");
	if (strcmpi(r, ON) == 0)
		shiftState = true;
	else
		shiftState = false;

	r = get_setting(INI_SECT_STATE, INI_AUTO_ATTK, "OFF");
	if (strcmpi(r, ON) == 0)
		autoAttack = STATE_ATK_DEFENSIVE;
	else
		autoAttack = STATE_ATK_NORMAL;

	r = get_setting(INI_SECT_STATE, INI_OVERHEAD_MSG, "ON");
	if (strcmpi(r, ON) == 0)
		toNotify = true;
	else
		toNotify = false;

	r = get_setting(INI_SECT_STATE, INI_TELE_STATE, "OFF");
	if (strcmpi(r, ON) == 0)
		toTeleport = true;
	else
		toTeleport = false;

}

//////////////////////////////////////////////////////////////////////
// get_setting
// -------------------------------------------------------------------
// get init file setting, with default handling
//////////////////////////////////////////////////////////////////////
char* get_setting(char* sect, char* key, char * default_setting)
{
	char * r = server->GetHackProfileString(FOLLOW_MODULE_NAME, sect, key);
	if (strlen(r)) 
		return r;

	return default_setting;
}

//////////////////////////////////////////////////////////////////////
// set_setting
// -------------------------------------------------------------------
// set init file 
//////////////////////////////////////////////////////////////////////
void set_setting(char* sect, char* key, bool val)
{
	if (val)
		server->SetHackProfileString(FOLLOW_MODULE_NAME, sect, key, ON);
	else
		server->SetHackProfileString(FOLLOW_MODULE_NAME, sect, key, OFF);
}


//////////////////////////////////////////////////////////////////////
// checkLeaderCmd
// -------------------------------------------------------------------
// check the verbal commands from master
//////////////////////////////////////////////////////////////////////
void checkLeaderCmd(BYTE* aPacket, DWORD aLen)
{
	//------------------------------------------------//
	// make sure cmd comes from the leader
	if (strcmpi(playerInGame[leaderPos].PlayerName, (char*) aPacket+10) == 0)
	{
		size_t s = strlen(playerInGame[leaderPos].PlayerName);

		//------------------------------------------------//
		// this is checked first before we check if we are currently following
		if (strcmpi(cmd_follow, (char*) (aPacket+11+s)) == 0)
		{
			toFollow = true;
			OverheadMsg("On my way");
			return;
		}

		//------------------------------------------------//
		// Cmd - Return to town
		if (strcmpi(cmd_rettown, (char*) (aPacket+11+s)) == 0)
		{
			if(Debug == DEBUG_DEVEL) 
			{
				sprintf(DebugBuffer,"Returning to Town");
				server->GamePrintString(DebugBuffer);
			}
			setSkill_TP();
			return;
		}

		//------------------------------------------------//
		// only check below if we are in follow mode.
		if (!toFollow) 
			return;

		//------------------------------------------------//
		// stay where u are
		else if (strcmpi(cmd_stay, (char*) (aPacket+11+s)) == 0)
		{
			OverheadMsg("Staying right here");
			OnGameCommandStop(NULL, 0);
			return;
		}
		//------------------------------------------------//
		// go out to the playing field (via previously cased master tp)
		else if (strcmpi(cmd_taketp, (char*) (aPacket+11+s)) == 0 )
		{
			if (take_tp_by_name(playerInGame[leaderPos].PlayerName))
				OverheadMsg("Going to portal");
			return;
		}
		//------------------------------------------------//
		// go out to the playing field (via a given tp)
		else if (strncmp(cmd_taketp, (char*) (aPacket+11+s), strlen(cmd_taketp)) == 0 )
		{
			if (take_tp_by_name((char*)(aPacket+11+strlen(cmd_taketp)+1+s)))
				OverheadMsg("Going to portal");
			return;
		}
		//------------------------------------------------//
		// go out to the playing field (via previously cased tp)
		else if (strcmpi(cmd_gofield, (char*) (aPacket+11+s)) == 0 &&
				 stateGotoTown == STATE_GOTO_TOWN_IDLE )
		{
			// for now assume we are close enough to the tp
			if (take_tp_by_name((char*)(thisgame->player->PlayerName)))
				OverheadMsg("As you command");
			return;
		}
		//------------------------------------------------//
		// switch/toggle left/right skill
		// expand this section for more controll over skills
		else if (strcmpi(cmd_switch, (char*) (aPacket+11+s)) == 0)
		{
			if (shiftState)
			{
				if (attackSkill == STATE_SKILL_SHIFT_LEFT)
				{
					attackSkill = STATE_SKILL_SHIFT_RIGHT;
					sprintf(DebugBuffer, "Using shift right skill: %s", game_skills[right_skill].name);
					OverheadMsg(DebugBuffer);
				}
				else
				{
					attackSkill = STATE_SKILL_SHIFT_LEFT;
					sprintf(DebugBuffer, "Using shift left skill: %s", game_skills[left_skill].name);
					OverheadMsg(DebugBuffer);
				}
			}
			else
			{
				if (attackSkill == STATE_SKILL_LEFT)
				{
					attackSkill = STATE_SKILL_RIGHT;
					sprintf(DebugBuffer, "Using right skill: %s", game_skills[right_skill].name);
					OverheadMsg(DebugBuffer);
				}
				else
				{
					attackSkill = STATE_SKILL_LEFT;
					sprintf(DebugBuffer, "Using left skill: %s", game_skills[left_skill].name);
					OverheadMsg(DebugBuffer);
				}
			}
			return;
		}
		//------------------------------------------------//
		// toggle attacking 
		else if (strcmpi(cmd_attack, (char*) (aPacket+11+s)) == 0)
		{
			toAttack = !toAttack;
			if (toAttack)
                OverheadMsg("Your enemies are mine too");
			else
                OverheadMsg("Hold Fire");

			return;
		}
		//------------------------------------------------//
		// take waypoint
		else if (strncmp(cmd_waypoint, (char*) (aPacket+11+s), strlen(cmd_waypoint)) == 0)
		{
			WPSTRUCT *destwp = getWPbyName((char*)(aPacket+11+strlen(cmd_waypoint)+1+s));
			if (destwp == NULL) 
				return;
			TakeWayPoint(wp.entityID, destwp->wpNum);
			return;
		}
		//------------------------------------------------//
		// weapon switch command
		else if (strcmpi(cmd_weaponswitch, (char*) (aPacket+11+s)) == 0)
		{
			BYTE weapons_witch[] = {0x60};
			server->GameSendPacketToServer(weapons_witch, 1);
			OverheadMsg("swap weapon");
			return;
		}
		//------------------------------------------------//
		// weapon switch command
		else if (strncmp(cmd_heal, (char*) (aPacket+11+s), 4) == 0)
		{
			if (aLen > (11+strlen(cmd_heal)+1+s))
			{
				int index = get_healer_by_name((char*)(aPacket+11+strlen(cmd_heal)+1+s));
				if (index == HEALER_ARRAY_SIZE)
					return;
				InteractWithEntity(1, healer[index].baseID);
			}
			else if (lastHealer_seen >= 0)
			{
				InteractWithEntity(1, healer[lastHealer_seen].baseID);
			}
			return;
		}
	}
}

//////////////////////////////////////////////////////////////////////
// walkInPortal
// -------------------------------------------------------------------
// TODO - modify to use packethelper
//////////////////////////////////////////////////////////////////////
void walkInPortal(BYTE* aPacket, DWORD aLen)
{
	stateGotoTown = STATE_GOTO_TOWN_IDLE;
	saPacket[0] = (BYTE) 0x13; // inter act with portal
	saPacket[1] = (BYTE) 0x02;
	saPacket[2] = (BYTE) 0x00;
	saPacket[3] = (BYTE) 0x00;
	saPacket[4] = (BYTE) 0x00;
    //TODO to be modifiled
	saPacket[5] = aPacket[2];  // 4 byte portal id from server packet
	saPacket[6] = aPacket[3];
	saPacket[7] = aPacket[4];
	saPacket[8] = aPacket[5];
	DWORD dummy1, dummy2;
	// create thread to ensure that there's a delay be we attempt to go into tp
	CreateThread(NULL, 0, SleepThread, &saPacket, 0, &dummy1);
	// create thread to ensure that state is reset
	CreateThread(NULL, 0, ResetThread, NULL, 0, &dummy2);
}

bool take_tp_by_name(char* ownerName)
{
	int lasttp = get_tp_by_name(ownerName);
	if (lasttp >= TP_ARRAY_SIZE) // can't find it
		return false;
	BYTE goin_tp[9];
	goin_tp[0] = (BYTE) 0x13; // inter act with portal
	goin_tp[1] = (BYTE) 0x02;
	goin_tp[2] = (BYTE) 0x00;
	goin_tp[3] = (BYTE) 0x00;
	goin_tp[4] = (BYTE) 0x00;
	goin_tp[5] = portals[lasttp].portalIdA[0]; // 4 byte portal id from server packet
	goin_tp[6] = portals[lasttp].portalIdA[1];
	goin_tp[7] = portals[lasttp].portalIdA[2];
	goin_tp[8] = portals[lasttp].portalIdA[3];

	server->GameSendPacketToServer(goin_tp, 9);
	//OverheadMsg("Going to portal");
	return true;
}


//////////////////////////////////////////////////////////////////////
// followLeader
// -------------------------------------------------------------------
// move to master's previous position
//////////////////////////////////////////////////////////////////////
void followLeader(BYTE* aPacket, DWORD aLen)
{
	memcpy (&leaderLoc.x, aPacket+12, 2);
	memcpy (&leaderLoc.y, aPacket+14, 2);

	BYTE follow[5];
	follow[0] = 0x03;
	memcpy (follow+1, aPacket+12, 2);
	memcpy (follow+3, aPacket+14, 2);
	server->GameSendPacketToServer(follow, 5);
}

void run_to_pos(DWORD *xy)
{
	BYTE run[5];
	run[0] = 0x03;
	memcpy (run+1, xy, 4);
	server->GameSendPacketToServer(run, 5);
}

void teleport_to_pos(DWORD *xy)
{
	WORD skill_id;

	setRightSkill(0x36); // set to teleport

	BYTE tele[5];
	tele[0] = 0x0c;
	memcpy (tele+1, xy, 4);
	server->GameSendPacketToServer(tele, 5);

	SKILL_OUT_CONV(right_skill, skill_id);
	setRightSkill(skill_id);
}
//////////////////////////////////////////////////////////////////////
// castTownPortal - from Chicken
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////
void castTownPortal(BYTE* aPacket, DWORD aLen)
{
	stateGotoTown = STATE_GOTO_TOWN_USING_SKILL;

	// Do this incase we need to check position later on - to be removed
	portalPos[0] = (BYTE) (thisgame->player->PlayerPositionX & 0xff);
	portalPos[1] = (BYTE) ((thisgame->player->PlayerPositionX >> 8) & 0xff);
	portalPos[2] = (BYTE) (thisgame->player->PlayerPositionY & 0xff);
	portalPos[3] = (BYTE) ((thisgame->player->PlayerPositionY >> 8) & 0xff);
	// Use Right Skill-TP (0x0c) at this position
	BYTE sPacket[5] = { (BYTE) 0x0c, portalPos[0], portalPos[1], portalPos[2], portalPos[3] };
	server->GameSendPacketToServer(sPacket, 5);
}



//////////////////////////////////////////////////////////////////////
// addPlayerInfo
// -------------------------------------------------------------------
// store player name and id
//////////////////////////////////////////////////////////////////////
int addPlayerInfo(BYTE* aPacket, DWORD aLen)
{
	int i = 0;
	int freeIndex = -1;
	for(i = 0; i < MAX_PLAYER_IN_GAME; i++)
	{
		// does player already exist in table?
		if (playerInGame[i].InUse == true && 
			strcmpi(playerInGame[i].PlayerName, (char*) aPacket+6) == 0)
			return i;
		else if(playerInGame[i].InUse == false && freeIndex == -1)
			freeIndex = i; // locate a free slot
	}

	if (freeIndex < 0) // more than 8 player impossible, but just in case 
		return (-1) ; 

	playerInGame[freeIndex].PlayerID = aPacket[1];
	strcpy(playerInGame[freeIndex].PlayerName, (const char*) aPacket+6);
	playerInGame[freeIndex].InUse = true;


	if (leaderId == 0 && strcmpi(playerInGame[freeIndex].PlayerName, leaderName) == 0)
	{
		toFollow = true;
		leaderId = playerInGame[freeIndex].PlayerID;
		leaderPos = freeIndex;
		sprintf(DebugBuffer,"Master c2%sc20(c3%dc0)", playerInGame[freeIndex].PlayerName, 
			playerInGame[freeIndex].PlayerID);
	}
	else
		sprintf(DebugBuffer,"Player c3%dc0, c2%sc20", playerInGame[freeIndex].PlayerID, 
									  playerInGame[freeIndex].PlayerName);

	server->GamePrintInfo(DebugBuffer);

	return freeIndex;
}

int add_PlayerInfo(BYTE* playerName, BYTE playerID)
{
	int i = 0;
	int freeIndex = -1;
	for(i = 0; i < MAX_PLAYER_IN_GAME; i++)
	{
		// does player already exist in table?
		if (playerInGame[i].InUse == true && 
			strcmpi(playerInGame[i].PlayerName, (char*) playerName) == 0)
			return i;
		else if(playerInGame[i].InUse == false && freeIndex == -1)
			freeIndex = i; // locate a free slot
	}

	if (freeIndex < 0) // more than 8 player impossible, but just in case 
		return (-1) ; 

	playerInGame[freeIndex].PlayerID = playerID;
	strcpy(playerInGame[freeIndex].PlayerName, (const char*) playerName);
	playerInGame[freeIndex].InUse = true;

	sprintf(DebugBuffer,"Player c3%dc0, c2%sc20", playerInGame[freeIndex].PlayerID, 
									  playerInGame[freeIndex].PlayerName);
	server->GamePrintInfo(DebugBuffer);
	return freeIndex;
}


//////////////////////////////////////////////////////////////////////
// removePlayerInfo
// -------------------------------------------------------------------
// remove by setting the InUse flag to false
//////////////////////////////////////////////////////////////////////
int removePlayerInfo(BYTE* aPacket, DWORD aLen)
{
	int i = 0;

	for(i = 0; i < MAX_PLAYER_IN_GAME; i++)
	{
		// find player in table
		if (playerInGame[i].InUse == true && 
			strcmpi(playerInGame[i].PlayerName, (char*) aPacket+8) == 0)
		{
			playerInGame[i].InUse = false;
			return i;
		}
	}
	// shouldn't get here
	return (-1);
}


//////////////////////////////////////////////////////////////////////
// setSkill_TP
// -------------------------------------------------------------------
// set right skill to tome of town portal
//////////////////////////////////////////////////////////////////////

void setSkill_TP()
{
	// set skill to TP
	stateGotoTown = STATE_GOTO_TOWN_SWITCHING_SKILL;
	BYTE sPacket[9] = { 0x3c, 0xdc, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff };
	server->GameSendPacketToServer(sPacket, 9);

	return;
}

// set right button skill
//sPacket[4] = 0x80; // for left button
void setRightSkill(WORD skill)
{
	BYTE sPacket[9] = { 0x3c, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff };
	memcpy(sPacket+1, &skill, 2);
	server->GameSendPacketToServer(sPacket, 9);
	return;
}


//////////////////////////////////////////////////////////////////////
// ResurrThread
// -------------------------------------------------------------------
// auto resurr bot
//////////////////////////////////////////////////////////////////////
DWORD WINAPI ResurrThread(LPVOID lpParameter)
{
	Sleep(5000);
	//server->GamePrintInfo("Resurr after 5");
	BYTE pPacket[] = {0x41};
	server->GameSendPacketToServer(pPacket, 1);
	return 0;
}

//////////////////////////////////////////////////////////////////////
// functions from CHICKEN - start
// -------------------------------------------------------------------
//////////////////////////////////////////////////////////////////////

DWORD WINAPI SleepThread(LPVOID lpParameter)
{
	BYTE *sPacket = (BYTE *) lpParameter;

	Sleep(1000);
	server->GameSendPacketToServer(sPacket, 9);
	return 0;
}

DWORD WINAPI ResetThread(LPVOID lpParameter)
{
	WORD skill_id;
	Sleep(2000);
	if (stateGotoTown == STATE_GOTO_TOWN_USING_SKILL)
	{
		server->GamePrintInfo("Cannot goto town, out of portals or in town already?");
		stateGotoTown = STATE_GOTO_TOWN_IDLE;
	}
	
	SKILL_OUT_CONV(right_skill, skill_id);
	setRightSkill(skill_id);

	return 0;
}

void OverheadMsg(char *Msg)
{
	BYTE aPacket[512];

	if (!toNotify) return;

	sprintf((char*)aPacket, "%c%c%c%s%c%c%c", 0x14, 0x00, 0x00, Msg, 0,0,0);
	server->GameSendPacketToServer(aPacket, strlen(Msg)+6);
}

void ChatMsg(char *Msg)
{
	BYTE aPacket[512];

	sprintf((char*)aPacket, "%c%c%c%s%c%c%c", 0x15, 0x01, 0x00, Msg, 0,0,0);
	server->GameSendPacketToServer(aPacket, strlen(Msg)+6);
}
// from CHICKEN - end



// from mousepad with some small mods
struct BitFields {
	BYTE *data;
	DWORD pos;
	DWORD max;
	BitFields(BYTE *d, DWORD mx) {
		data = d; 
		pos = 0; 
		max = (mx * 8);  // convert to max bits
	}
	DWORD GetField(DWORD len) {
		return GetBitField(data, (pos+=len)-len, len, max);
	}
};

// from mousepad with some small mods
DWORD GetBitField(BYTE* data, DWORD pos, DWORD len, DWORD max) {
	// trying to read beyond the end of the packet

	if(pos + len > max) {

		// if we are already at or beyond the end of packet, return 0;
		if(pos >= max) {
			return 0;
		}
		// otherwise adjust len to all remaining bits
		if(Debug == DEBUG_PACKET) {
			sprintf(DebugBuffer,"Trying to read beyond eop. len:%d pos:%d max:%d",len,pos,max);
			server->GamePrintString(DebugBuffer);
		}
		len = max - pos;
	}

	return (DWORD)(*(unsigned __int64 *)(data+pos/8)<<(64-len-(pos&7))>>(64-len));
}
// from SHOPBOT - end




	//------------------------------------------------//
	// Packet 96
	// location sync from server
	// if(aPacket[0] == 0x96) 
	// { 
	//	if(Debug == DEBUG_DEVEL) {
	//		BitFields iPacket(aPacket,aLen);
	//		iPacket.GetField(23);
	//		LOCATIONSTRUCT loc;
	//		loc.x = iPacket.GetField(16);
	//		loc.y = iPacket.GetField(16);
	//		sprintf(DebugBuffer,"Location Sync from server (%d,%d)",loc.x,loc.y);
	//		server->GamePrintString(DebugBuffer);
	//	}
	//	return aLen;
    // } 


	//------------------------------------------------//
	// Packet 95 - life/mana update
	// Update HP, MP
	//if (aPacket[0] == 0x95)
	//{
	//	CurrentHP = *((WORD *)(aPacket + 1)) & 0x0FFF;
	//	CurrentMP = (*((WORD *)(aPacket + 3)) & 0x0FFF) << 1;
	//}
