// Optimal Genes
// data from LVLWRAP.txt, Lvltype.txt, levels.txt

#include "lvlwrap.h"

LVLWRAPSTRUCT lvl_wrap_data[] = {
	//	{"Name",	Id},
	{"Act 1 Wilderness to Cave Cliff L",	0},
	{"Act 1 Wilderness to Cave Cliff R",	1},
	{"Act 1 Wilderness to Cave Floor L",	2},
	{"Act 1 Wilderness to Cave Floor R",	3},
	{"Act 1 Cave Up",			4},
	{"Act 1 Cave Down",			5},
	{"Act 1 Graveyard to Crypt 1",		6},
	{"Act 1 Graveyard to Crypt 2",		7},
	{"Act 1 Crypt Up",			8},
	{"Act 1 Crypt Down",			9},
	{"Act 1 Wilderness to Tower",		10},
	{"Act 1 Tower to Wilderness",		11},
	{"Act 1 Tower to Crypt",		12},
	{"Act 1 Jail Up",			13},
	{"Act 1 Jail Down",			14},
	{"Act 1 Cathedral To Catacombs",	15},
	{"Act 1 Catacombs to Cathedral",	16},
	{"Act 1 Catacombs Up",			17},
	{"Act 1 Catacombs Down",		18},
	{"Act 2 Town to Sewer Trap",		19},
	{"Act 2 Town to Sewer Dock",		20},
	{"Act 2 Sewer Dock to Town",		21},
	{"Act 2 Sewer Up",			22},
	{"Act 2 Sewer Down",			23},
	{"Act 2 Town to Harem",			24},
	{"Act 2 Harem to Town",			25},
	{"Act 2 Harem Up 1",			26},
	{"Act 2 Harem Up 2",			27},
	{"Act 2 Harem Down 1",			28},
	{"Act 2 Harem Down 2",			29},
	{"Act 2 Basement Up 1",			30},
	{"Act 2 Basement Up 2",			31},
	{"Act 2 Basement Down",			32},
	{"Act 2 Desert to Tomb L 1",		33},
	{"Act 2 Desert to Tomb L 2",		34},
	{"Act 2 Desert to Tomb R 1",		35},
	{"Act 2 Desert to Tomb R 2",		36},
	{"Act 2 Desert to Tomb Viper",		37},
	{"Act 2 Desert to Tomb Tal 1",		38},
	{"Act 2 Desert to Tomb Tal 2",		39},
	{"Act 2 Desert to Tomb Tal 3",		40},
	{"Act 2 Desert to Tomb Tal 4",		41},
	{"Act 2 Desert to Tomb Tal 5",		42},
	{"Act 2 Desert to Tomb Tal 6",		43},
	{"Act 2 Desert to Tomb Tal 7",		44},
	{"Act 2 Tomb Up",			45},
	{"Act 2 Tomb Down",			46},
	{"Act 2 Desert to Lair",		47},
	{"Act 2 Lair Up",			48},
	{"Act 2 Lair Down",			49},
	{"Act 2 Desert to Sewer Trap",		50},
	{"Act 3 Jungle to Spider",		51},
	{"Act 3 Spider to Jungle",		52},
	{"Act 3 Jungle to Dungeon Fort",	53},
	{"Act 3 Jungle to Dungeon Hole",	54},
	{"Act 3 Dungeon Up",			55},
	{"Act 3 Dungeon Down",			56},
	{"Act 3 Kurast to Sewer",		57},
	{"Act 3 Sewer Up L",			58},
	{"Act 3 Sewer Up R",			59},
	{"Act 3 Sewer Down",			60},
	{"Act 3 Kurast to Temple",		61},
	{"Act 3 Temple Up L",			62},
	{"Act 3 Temple Up R",			63},
	{"Act 3 Travincal to Mephisto",		64},
	{"Act 3 Mephisto Up L",	65},
	{"Act 3 Mephisto Up R",	66},
	{"Act 3 Mephisto Down L",	67},
	{"Act 3 Mephisto Down R",	68},
	{"Act 4 Mesa to Lava",	69},
	{"Act 4 Lava to Mesa",	70},
	{"Expansion",	},
	{"Act 5 Barricade Down Wall",	71},
	{"Act 5 Barricade Down Wall",	71},
	{"Act 5 Barricade Down Floor",	72},
	{"Act 5 Ice Caves Up",	73},
	{"Act 5 Ice Caves Up",	73},
	{"Act 5 Ice Caves Down",	74},
	{"Act 5 Ice Caves Down",	74},
	{"Act 5 Ice Caves Down Floor",	75},
	{"Act 5 Temple Entrance",	76},
	{"Act 5 Temple Down",	77},
	{"Act 5 Temple Up",	78},
	{"Act 5 Mountain Top To Ice",	79},
	{"Act 5 Mountain Top To Baal",	80},
	{"Act 5 Baal Temple Up",	81},
	{"Act 5 Baal Temple Up",	81},
	{"Act 5 Baal Temple Down",	82},
	{"Act 5 Baal Temple Down",	82}
};


LVLWRAPSTRUCT lvl_data[] = {
	{"Name", 			0},
	{"Act 1 - Town",		1},
	{"Act 1 - Wilderness",		2},
	{"Act 1 - Cave",		3},
	{"Act 1 - Crypt",		4},
	{"Act 1 - Monestary",		5},
	{"Act 1 - Courtyard",		6},
	{"Act 1 - Barracks",		7},
	{"Act 1 - Jail",		8},
	{"Act 1 - Cathedral",		9},
	{"Act 1 - Catacombs",		10},
	{"Act 1 - Tristram",		11},
	{"Act 2 - Town",		12},
	{"Act 2 - Sewer",		13},
	{"Act 2 - Harem",		14},
	{"Act 2 - Basement",		15},
	{"Act 2 - Desert",		16},
	{"Act 2 - Tomb",		17},
	{"Act 2 - Lair",		18},
	{"Act 2 - Arcane",		19},
	{"Act 3 - Town",		20},
	{"Act 3 - Jungle",		21},
	{"Act 3 - Kurast",		22},
	{"Act 3 - Spider",		23},
	{"Act 3 - Dungeon",		24},
	{"Act 3 - Sewer",		25},
	{"Act 4 - Town",		26},
	{"Act 4 - Mesa",		27},
	{"Act 4 - Lava",		28},
	{"Act 5 - Town",		29},
	{"Act 5 - Siege",		30},
	{"Act 5 - Barricade",		31},
	{"Act 5 - Temple",		32},
	{"Act 5 - Ice Caves",		33},
	{"Act 5 - Baal",		34},
	{"Act 5 - Lava",		35}
};

LVLNAMESTRUCT lvl_name_data[] = {
	//{"LevelName",                                Id,	Act,	Waypoint},
	{"Name",                                     0,	0,	255},
	{"Rogue Encampment",                         1,	0,	0},
	{"Blood Moor",                               2,	0,	255},
	{"Cold Plains",                              3,	0,	1},
	{"Stony Field",                              4,	0,	2},
	{"Dark Wood",                                5,	0,	3},
	{"Black Marsh",                              6,	0,	4},
	{"Tamoe Highland",                           7,	0,	255},
	{"Den of Evil",                              8,	0,	255},
	{"Cave Level 1",                             9,	0,	255},
	{"Underground Passage Level 1",              10,	0,	255},
	{"Hole Level 1",                             11,	0,	255},
	{"Pit Level 1",                              12,	0,	255},
	{"Cave Level 2",                             13,	0,	255},
	{"Underground Passage Level 2",              14,	0,	255},
	{"Hole Level 2",                             15,	0,	255},
	{"Pit Level 2",                              16,	0,	255},
	{"Burial Grounds",                           17,	0,	255},
	{"Crypt",                                    18,	0,	255},
	{"Mausoleum",                                19,	0,	255},
	{"Forgotten Tower",                          20,	0,	255},
	{"Tower Cellar Level 1",                     21,	0,	255},
	{"Tower Cellar Level 2",                     22,	0,	255},
	{"Tower Cellar Level 3",                     23,	0,	255},
	{"Tower Cellar Level 4",                     24,	0,	255},
	{"Tower Cellar Level 5",                     25,	0,	255},
	{"Monastery Gate",                           26,	0,	255},
	{"Outer Cloister",                           27,	0,	5},
	{"Barracks",                                 28,	0,	255},
	{"Jail Level 1",                             29,	0,	6},
	{"Jail Level 2",                             30,	0,	255},
	{"Jail Level 3",                             31,	0,	255},
	{"Inner Cloister",                           32,	0,	7},
	{"Cathedral",                                33,	0,	255},
	{"Catacombs Level 1",                        34,	0,	255},
	{"Catacombs Level 2",                        35,	0,	8},
	{"Catacombs Level 3",                        36,	0,	255},
	{"Catacombs Level 4",                        37,	0,	255},
	{"Tristram",                                 38,	0,	255},
	{"Moo Moo Farm",                             39,	0,	255},
	{"Lut Gholein",                              40,	1,	9},
	{"Rocky Waste",                              41,	1,	255},
	{"Dry Hills",                                42,	1,	11},
	{"Far Oasis",                                43,	1,	13},
	{"Lost City",                                44,	1,	14},
	{"Valley of Snakes",                         45,	1,	255},
	{"Canyon of the Magi",                       46,	1,	17},
	{"Sewers Level 1",                           47,	1,	255},
	{"Sewers Level 2",                           48,	1,	10},
	{"Sewers Level 3",                           49,	1,	255},
	{"Harem Level 1",                            50,	1,	255},
	{"Harem Level 2",                            51,	1,	255},
	{"Palace Cellar Level 1 ",                   52,	1,	15},
	{"Palace Cellar Level 2",                    53,	1,	255},
	{"Palace Cellar Level 3",                    54,	1,	255},
	{"Stony Tomb Level 1",                       55,	1,	255},
	{"Halls of the Dead Level 1",                56,	1,	255},
	{"Halls of the Dead Level 2",                57,	1,	12},
	{"Claw Viper Temple Level 1",                58,	1,	255},
	{"Stony Tomb Level 2",                       59,	1,	255},
	{"Halls of the Dead Level 3",                60,	1,	255},
	{"Claw Viper Temple Level 2",                61,	1,	255},
	{"Maggot Lair Level 1",                      62,	1,	255},
	{"Maggot Lair Level 2",                      63,	1,	255},
	{"Maggot Lair Level 3",                      64,	1,	255},
	{"Ancient Tunnels",                          65,	1,	255},
	{"Tal Rasha's Tomb",                         66,	1,	255},
	{"Tal Rasha's Tomb",                         67,	1,	255},
	{"Tal Rasha's Tomb",                         68,	1,	255},
	{"Tal Rasha's Tomb",                         69,	1,	255},
	{"Tal Rasha's Tomb",                         70,	1,	255},
	{"Tal Rasha's Tomb",                         71,	1,	255},
	{"Tal Rasha's Tomb",                         72,	1,	255},
	{"Duriel's Lair",                            73,	1,	255},
	{"Arcane Sanctuary",                         74,	1,	16},
	{"Kurast Docktown",                          75,	2,	18},
	{"Spider Forest",                            76,	2,	19},
	{"Great Marsh",                              77,	2,	20},
	{"Flayer Jungle",                            78,	2,	21},
	{"Lower Kurast",                             79,	2,	22},
	{"Kurast Bazaar",                            80,	2,	23},
	{"Upper Kurast",                             81,	2,	24},
	{"Kurast Causeway",                          82,	2,	255},
	{"Travincal",                                83,	2,	25},
	{"Spider Cave",                              84,	2,	255},
	{"Spider Cavern",                            85,	2,	255},
	{"Swampy Pit Level 1",                       86,	2,	255},
	{"Swampy Pit Level 2",                       87,	2,	255},
	{"Flayer Dungeon Level 1",                   88,	2,	255},
	{"Flayer Dungeon Level 2",                   89,	2,	255},
	{"Swampy Pit Level 3",                       90,	2,	255},
	{"Flayer Dungeon Level 3",                   91,	2,	255},
	{"Sewers Level 1",                           92,	2,	255},
	{"Sewers Level 2",                           93,	2,	255},
	{"Ruined Temple",                            94,	2,	255},
	{"Disused Fane",                             95,	2,	255},
	{"Forgotten Reliquary",                      96,	2,	255},
	{"Forgotten Temple",                         97,	2,	255},
	{"Ruined Fane",                              98,	2,	255},
	{"Disused Reliquary",                        99,	2,	255},
	{"Durance of Hate Level 1",                  100,	2,	255},
	{"Durance of Hate Level 2",                  101,	2,	26},
	{"Durance of Hate Level 3",                  102,	2,	255},
	{"The Pandemonium Fortress",                 103,	3,	27},
	{"Outer Steppes",                            104,	3,	255},
	{"Plains of Despair",                        105,	3,	255},
	{"City of the Damned",                       106,	3,	28},
	{"River of Flame",                           107,	3,	29},
	{"Chaos Sanctum",                            108,	3,	255},
	{"Harrogath",                                109,	4,	30},
	{"Bloody Foothills",                         110,	4,	255},
	{"Frigid Highlands",                          111,	4,	31}, // "Rigid Highlands"
	{"Arreat Plateau",                           112,	4,	32},
	{"Crystalline Passage",			             113,	4,	33}, // "Crystalized Cavern Level 1"
	{"Frozen River",                             114,	4,	255}, // "Cellar of Pity"
	{"Glacial Trail",			                 115,	4,	34}, // "Crystalized Cavern Level 2"
	{"Echo Chamber",                             116,	4,	255},
	{"Frozen Tundra",	                         117,	4,	36},// "Tundra Wastelands"
	{"The Ancients' Way",						 118,	4,	37}, // "Glacial Caves Level 1"
	{"Glacial Caves Level 2",                    119,	4,	255},
	{"Rocky Summit",                             120,	4,	255},
	{"Nihlathaks Temple",                        121,	4,	255},
	{"Halls of Anguish",                         122,	4,	255},
	{"Halls of Pain",			                 123,	4,	35}, // "Halls of Death's Calling"
	{"Halls of Vaught",                          124,	4,	255},
	{"Hell1",                                    125,	4,	255},
	{"Hell2",                                    126,	4,	255},
	{"Hell3",                                    127,	4,	255},
	{"The Worldstone Keep Level 1",              128,	4,	255},
	{"Worldstone Keep Level 2",	                 129,	4,	38}, //"The Worldstone Keep Level 2"
	{"The Worldstone Keep Level 3",              130,	4,	255},
	{"Throne of Destruction",                    131,	4,	255},
	{"The Worldstone Chamber",                   132,	4,	255},
} ;








